"""
    Production API

    API exposing endpoints for managing well  and daily production.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

import nulltype  # noqa: F401

from openapi_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class WellInput(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'PRODUCER': "PRODUCER",
            'INJECTOR': "INJECTOR",
        },
        ('fluid',): {
            'OIL': "OIL",
            'GAS': "GAS",
            'WATER': "WATER",
        },
        ('lift_type',): {
            'NATURAL_FLOW': "NATURAL_FLOW",
            'GAS_LIFT': "GAS_LIFT",
            'ROD_PUMP': "ROD_PUMP",
            'ESP': "ESP",
            'PLUNGER_LIFT': "PLUNGER_LIFT",
            'GAS_ASSISTED_PLUNGER_LIFT': "GAS_ASSISTED_PLUNGER_LIFT",
        },
        ('timezone',): {
            'None': None,
            'DEFAULT': "DEFAULT",
            'ACT': "ACT",
            'AET': "AET",
            'AFRICA_ABIDJAN': "AFRICA_ABIDJAN",
            'AFRICA_ACCRA': "AFRICA_ACCRA",
            'AFRICA_ADDIS_ABABA': "AFRICA_ADDIS_ABABA",
            'AFRICA_ALGIERS': "AFRICA_ALGIERS",
            'AFRICA_ASMERA': "AFRICA_ASMERA",
            'AFRICA_BAMAKO': "AFRICA_BAMAKO",
            'AFRICA_BANGUI': "AFRICA_BANGUI",
            'AFRICA_BANJUL': "AFRICA_BANJUL",
            'AFRICA_BISSAU': "AFRICA_BISSAU",
            'AFRICA_BLANTYRE': "AFRICA_BLANTYRE",
            'AFRICA_BRAZZAVILLE': "AFRICA_BRAZZAVILLE",
            'AFRICA_BUJUMBURA': "AFRICA_BUJUMBURA",
            'AFRICA_CAIRO': "AFRICA_CAIRO",
            'AFRICA_CASABLANCA': "AFRICA_CASABLANCA",
            'AFRICA_CEUTA': "AFRICA_CEUTA",
            'AFRICA_CONAKRY': "AFRICA_CONAKRY",
            'AFRICA_DAKAR': "AFRICA_DAKAR",
            'AFRICA_DAR_ES_SALAAM': "AFRICA_DAR_ES_SALAAM",
            'AFRICA_DJIBOUTI': "AFRICA_DJIBOUTI",
            'AFRICA_DOUALA': "AFRICA_DOUALA",
            'AFRICA_EL_AAIUN': "AFRICA_EL_AAIUN",
            'AFRICA_FREETOWN': "AFRICA_FREETOWN",
            'AFRICA_GABORONE': "AFRICA_GABORONE",
            'AFRICA_HARARE': "AFRICA_HARARE",
            'AFRICA_JOHANNESBURG': "AFRICA_JOHANNESBURG",
            'AFRICA_KAMPALA': "AFRICA_KAMPALA",
            'AFRICA_KHARTOUM': "AFRICA_KHARTOUM",
            'AFRICA_KIGALI': "AFRICA_KIGALI",
            'AFRICA_KINSHASA': "AFRICA_KINSHASA",
            'AFRICA_LAGOS': "AFRICA_LAGOS",
            'AFRICA_LIBREVILLE': "AFRICA_LIBREVILLE",
            'AFRICA_LOME': "AFRICA_LOME",
            'AFRICA_LUANDA': "AFRICA_LUANDA",
            'AFRICA_LUBUMBASHI': "AFRICA_LUBUMBASHI",
            'AFRICA_LUSAKA': "AFRICA_LUSAKA",
            'AFRICA_MALABO': "AFRICA_MALABO",
            'AFRICA_MAPUTO': "AFRICA_MAPUTO",
            'AFRICA_MASERU': "AFRICA_MASERU",
            'AFRICA_MBABANE': "AFRICA_MBABANE",
            'AFRICA_MOGADISHU': "AFRICA_MOGADISHU",
            'AFRICA_MONROVIA': "AFRICA_MONROVIA",
            'AFRICA_NAIROBI': "AFRICA_NAIROBI",
            'AFRICA_NDJAMENA': "AFRICA_NDJAMENA",
            'AFRICA_NIAMEY': "AFRICA_NIAMEY",
            'AFRICA_NOUAKCHOTT': "AFRICA_NOUAKCHOTT",
            'AFRICA_OUAGADOUGOU': "AFRICA_OUAGADOUGOU",
            'AFRICA_PORTO_NOVO': "AFRICA_PORTO_NOVO",
            'AFRICA_SAO_TOME': "AFRICA_SAO_TOME",
            'AFRICA_TIMBUKTU': "AFRICA_TIMBUKTU",
            'AFRICA_TRIPOLI': "AFRICA_TRIPOLI",
            'AFRICA_TUNIS': "AFRICA_TUNIS",
            'AFRICA_WINDHOEK': "AFRICA_WINDHOEK",
            'AGT': "AGT",
            'AMERICA_ADAK': "AMERICA_ADAK",
            'AMERICA_ANCHORAGE': "AMERICA_ANCHORAGE",
            'AMERICA_ANGUILLA': "AMERICA_ANGUILLA",
            'AMERICA_ANTIGUA': "AMERICA_ANTIGUA",
            'AMERICA_ARAGUAINA': "AMERICA_ARAGUAINA",
            'AMERICA_ARUBA': "AMERICA_ARUBA",
            'AMERICA_ASUNCION': "AMERICA_ASUNCION",
            'AMERICA_ATKA': "AMERICA_ATKA",
            'AMERICA_BARBADOS': "AMERICA_BARBADOS",
            'AMERICA_BELEM': "AMERICA_BELEM",
            'AMERICA_BELIZE': "AMERICA_BELIZE",
            'AMERICA_BOA_VISTA': "AMERICA_BOA_VISTA",
            'AMERICA_BOGOTA': "AMERICA_BOGOTA",
            'AMERICA_BOISE': "AMERICA_BOISE",
            'AMERICA_BUENOS_AIRES': "AMERICA_BUENOS_AIRES",
            'AMERICA_CAMBRIDGE_BAY': "AMERICA_CAMBRIDGE_BAY",
            'AMERICA_CANCUN': "AMERICA_CANCUN",
            'AMERICA_CARACAS': "AMERICA_CARACAS",
            'AMERICA_CATAMARCA': "AMERICA_CATAMARCA",
            'AMERICA_CAYENNE': "AMERICA_CAYENNE",
            'AMERICA_CAYMAN': "AMERICA_CAYMAN",
            'AMERICA_CHICAGO': "AMERICA_CHICAGO",
            'AMERICA_CHIHUAHUA': "AMERICA_CHIHUAHUA",
            'AMERICA_CORDOBA': "AMERICA_CORDOBA",
            'AMERICA_COSTA_RICA': "AMERICA_COSTA_RICA",
            'AMERICA_CUIABA': "AMERICA_CUIABA",
            'AMERICA_CURACAO': "AMERICA_CURACAO",
            'AMERICA_DANMARKSHAVN': "AMERICA_DANMARKSHAVN",
            'AMERICA_DAWSON': "AMERICA_DAWSON",
            'AMERICA_DAWSON_CREEK': "AMERICA_DAWSON_CREEK",
            'AMERICA_DENVER': "AMERICA_DENVER",
            'AMERICA_DETROIT': "AMERICA_DETROIT",
            'AMERICA_DOMINICA': "AMERICA_DOMINICA",
            'AMERICA_EDMONTON': "AMERICA_EDMONTON",
            'AMERICA_EIRUNEPE': "AMERICA_EIRUNEPE",
            'AMERICA_EL_SALVADOR': "AMERICA_EL_SALVADOR",
            'AMERICA_ENSENADA': "AMERICA_ENSENADA",
            'AMERICA_FORT_WAYNE': "AMERICA_FORT_WAYNE",
            'AMERICA_FORTALEZA': "AMERICA_FORTALEZA",
            'AMERICA_GLACE_BAY': "AMERICA_GLACE_BAY",
            'AMERICA_GODTHAB': "AMERICA_GODTHAB",
            'AMERICA_GOOSE_BAY': "AMERICA_GOOSE_BAY",
            'AMERICA_GRAND_TURK': "AMERICA_GRAND_TURK",
            'AMERICA_GRENADA': "AMERICA_GRENADA",
            'AMERICA_GUADELOUPE': "AMERICA_GUADELOUPE",
            'AMERICA_GUATEMALA': "AMERICA_GUATEMALA",
            'AMERICA_GUAYAQUIL': "AMERICA_GUAYAQUIL",
            'AMERICA_GUYANA': "AMERICA_GUYANA",
            'AMERICA_HALIFAX': "AMERICA_HALIFAX",
            'AMERICA_HAVANA': "AMERICA_HAVANA",
            'AMERICA_HERMOSILLO': "AMERICA_HERMOSILLO",
            'AMERICA_INDIANA_INDIANAPOLIS': "AMERICA_INDIANA_INDIANAPOLIS",
            'AMERICA_INDIANA_KNOX': "AMERICA_INDIANA_KNOX",
            'AMERICA_INDIANA_MARENGO': "AMERICA_INDIANA_MARENGO",
            'AMERICA_INDIANA_VEVAY': "AMERICA_INDIANA_VEVAY",
            'AMERICA_INDIANAPOLIS': "AMERICA_INDIANAPOLIS",
            'AMERICA_INUVIK': "AMERICA_INUVIK",
            'AMERICA_IQALUIT': "AMERICA_IQALUIT",
            'AMERICA_JAMAICA': "AMERICA_JAMAICA",
            'AMERICA_JUJUY': "AMERICA_JUJUY",
            'AMERICA_JUNEAU': "AMERICA_JUNEAU",
            'AMERICA_KENTUCKY_LOUISVILLE': "AMERICA_KENTUCKY_LOUISVILLE",
            'AMERICA_KENTUCKY_MONTICELLO': "AMERICA_KENTUCKY_MONTICELLO",
            'AMERICA_KNOX_IN': "AMERICA_KNOX_IN",
            'AMERICA_LA_PAZ': "AMERICA_LA_PAZ",
            'AMERICA_LIMA': "AMERICA_LIMA",
            'AMERICA_LOS_ANGELES': "AMERICA_LOS_ANGELES",
            'AMERICA_LOUISVILLE': "AMERICA_LOUISVILLE",
            'AMERICA_MACEIO': "AMERICA_MACEIO",
            'AMERICA_MANAGUA': "AMERICA_MANAGUA",
            'AMERICA_MANAUS': "AMERICA_MANAUS",
            'AMERICA_MARTINIQUE': "AMERICA_MARTINIQUE",
            'AMERICA_MAZATLAN': "AMERICA_MAZATLAN",
            'AMERICA_MENDOZA': "AMERICA_MENDOZA",
            'AMERICA_MENOMINEE': "AMERICA_MENOMINEE",
            'AMERICA_MERIDA': "AMERICA_MERIDA",
            'AMERICA_MEXICO_CITY': "AMERICA_MEXICO_CITY",
            'AMERICA_MIQUELON': "AMERICA_MIQUELON",
            'AMERICA_MONTERREY': "AMERICA_MONTERREY",
            'AMERICA_MONTEVIDEO': "AMERICA_MONTEVIDEO",
            'AMERICA_MONTREAL': "AMERICA_MONTREAL",
            'AMERICA_MONTSERRAT': "AMERICA_MONTSERRAT",
            'AMERICA_NASSAU': "AMERICA_NASSAU",
            'AMERICA_NEW_YORK': "AMERICA_NEW_YORK",
            'AMERICA_NIPIGON': "AMERICA_NIPIGON",
            'AMERICA_NOME': "AMERICA_NOME",
            'AMERICA_NORONHA': "AMERICA_NORONHA",
            'AMERICA_NORTH_DAKOTA_CENTER': "AMERICA_NORTH_DAKOTA_CENTER",
            'AMERICA_PANAMA': "AMERICA_PANAMA",
            'AMERICA_PANGNIRTUNG': "AMERICA_PANGNIRTUNG",
            'AMERICA_PARAMARIBO': "AMERICA_PARAMARIBO",
            'AMERICA_PHOENIX': "AMERICA_PHOENIX",
            'AMERICA_PORT_AU_PRINCE': "AMERICA_PORT_AU_PRINCE",
            'AMERICA_PORT_OF_SPAIN': "AMERICA_PORT_OF_SPAIN",
            'AMERICA_PORTO_ACRE': "AMERICA_PORTO_ACRE",
            'AMERICA_PORTO_VELHO': "AMERICA_PORTO_VELHO",
            'AMERICA_PUERTO_RICO': "AMERICA_PUERTO_RICO",
            'AMERICA_RAINY_RIVER': "AMERICA_RAINY_RIVER",
            'AMERICA_RANKIN_INLET': "AMERICA_RANKIN_INLET",
            'AMERICA_RECIFE': "AMERICA_RECIFE",
            'AMERICA_REGINA': "AMERICA_REGINA",
            'AMERICA_RIO_BRANCO': "AMERICA_RIO_BRANCO",
            'AMERICA_ROSARIO': "AMERICA_ROSARIO",
            'AMERICA_SANTIAGO': "AMERICA_SANTIAGO",
            'AMERICA_SANTO_DOMINGO': "AMERICA_SANTO_DOMINGO",
            'AMERICA_SAO_PAULO': "AMERICA_SAO_PAULO",
            'AMERICA_SCORESBYSUND': "AMERICA_SCORESBYSUND",
            'AMERICA_SHIPROCK': "AMERICA_SHIPROCK",
            'AMERICA_ST_JOHNS': "AMERICA_ST_JOHNS",
            'AMERICA_ST_KITTS': "AMERICA_ST_KITTS",
            'AMERICA_ST_LUCIA': "AMERICA_ST_LUCIA",
            'AMERICA_ST_THOMAS': "AMERICA_ST_THOMAS",
            'AMERICA_ST_VINCENT': "AMERICA_ST_VINCENT",
            'AMERICA_SWIFT_CURRENT': "AMERICA_SWIFT_CURRENT",
            'AMERICA_TEGUCIGALPA': "AMERICA_TEGUCIGALPA",
            'AMERICA_THULE': "AMERICA_THULE",
            'AMERICA_THUNDER_BAY': "AMERICA_THUNDER_BAY",
            'AMERICA_TIJUANA': "AMERICA_TIJUANA",
            'AMERICA_TORTOLA': "AMERICA_TORTOLA",
            'AMERICA_VANCOUVER': "AMERICA_VANCOUVER",
            'AMERICA_VIRGIN': "AMERICA_VIRGIN",
            'AMERICA_WHITEHORSE': "AMERICA_WHITEHORSE",
            'AMERICA_WINNIPEG': "AMERICA_WINNIPEG",
            'AMERICA_YAKUTAT': "AMERICA_YAKUTAT",
            'AMERICA_YELLOWKNIFE': "AMERICA_YELLOWKNIFE",
            'ANTARCTICA_CASEY': "ANTARCTICA_CASEY",
            'ANTARCTICA_DAVIS': "ANTARCTICA_DAVIS",
            'ANTARCTICA_DUMONTDURVILLE': "ANTARCTICA_DUMONTDURVILLE",
            'ANTARCTICA_MAWSON': "ANTARCTICA_MAWSON",
            'ANTARCTICA_MCMURDO': "ANTARCTICA_MCMURDO",
            'ANTARCTICA_PALMER': "ANTARCTICA_PALMER",
            'ANTARCTICA_ROTHERA': "ANTARCTICA_ROTHERA",
            'ANTARCTICA_SOUTH_POLE': "ANTARCTICA_SOUTH_POLE",
            'ANTARCTICA_SYOWA': "ANTARCTICA_SYOWA",
            'ANTARCTICA_VOSTOK': "ANTARCTICA_VOSTOK",
            'ARCTIC_LONGYEARBYEN': "ARCTIC_LONGYEARBYEN",
            'ART': "ART",
            'ASIA_ADEN': "ASIA_ADEN",
            'ASIA_ALMATY': "ASIA_ALMATY",
            'ASIA_AMMAN': "ASIA_AMMAN",
            'ASIA_ANADYR': "ASIA_ANADYR",
            'ASIA_AQTAU': "ASIA_AQTAU",
            'ASIA_AQTOBE': "ASIA_AQTOBE",
            'ASIA_ASHGABAT': "ASIA_ASHGABAT",
            'ASIA_ASHKHABAD': "ASIA_ASHKHABAD",
            'ASIA_BAGHDAD': "ASIA_BAGHDAD",
            'ASIA_BAHRAIN': "ASIA_BAHRAIN",
            'ASIA_BAKU': "ASIA_BAKU",
            'ASIA_BANGKOK': "ASIA_BANGKOK",
            'ASIA_BEIRUT': "ASIA_BEIRUT",
            'ASIA_BISHKEK': "ASIA_BISHKEK",
            'ASIA_BRUNEI': "ASIA_BRUNEI",
            'ASIA_CALCUTTA': "ASIA_CALCUTTA",
            'ASIA_CHOIBALSAN': "ASIA_CHOIBALSAN",
            'ASIA_CHONGQING': "ASIA_CHONGQING",
            'ASIA_CHUNGKING': "ASIA_CHUNGKING",
            'ASIA_COLOMBO': "ASIA_COLOMBO",
            'ASIA_DACCA': "ASIA_DACCA",
            'ASIA_DAMASCUS': "ASIA_DAMASCUS",
            'ASIA_DHAKA': "ASIA_DHAKA",
            'ASIA_DILI': "ASIA_DILI",
            'ASIA_DUBAI': "ASIA_DUBAI",
            'ASIA_DUSHANBE': "ASIA_DUSHANBE",
            'ASIA_GAZA': "ASIA_GAZA",
            'ASIA_HARBIN': "ASIA_HARBIN",
            'ASIA_HONG_KONG': "ASIA_HONG_KONG",
            'ASIA_HOVD': "ASIA_HOVD",
            'ASIA_IRKUTSK': "ASIA_IRKUTSK",
            'ASIA_ISTANBUL': "ASIA_ISTANBUL",
            'ASIA_JAKARTA': "ASIA_JAKARTA",
            'ASIA_JAYAPURA': "ASIA_JAYAPURA",
            'ASIA_JERUSALEM': "ASIA_JERUSALEM",
            'ASIA_KABUL': "ASIA_KABUL",
            'ASIA_KAMCHATKA': "ASIA_KAMCHATKA",
            'ASIA_KARACHI': "ASIA_KARACHI",
            'ASIA_KASHGAR': "ASIA_KASHGAR",
            'ASIA_KATMANDU': "ASIA_KATMANDU",
            'ASIA_KRASNOYARSK': "ASIA_KRASNOYARSK",
            'ASIA_KUALA_LUMPUR': "ASIA_KUALA_LUMPUR",
            'ASIA_KUCHING': "ASIA_KUCHING",
            'ASIA_KUWAIT': "ASIA_KUWAIT",
            'ASIA_MACAO': "ASIA_MACAO",
            'ASIA_MACAU': "ASIA_MACAU",
            'ASIA_MAGADAN': "ASIA_MAGADAN",
            'ASIA_MAKASSAR': "ASIA_MAKASSAR",
            'ASIA_MANILA': "ASIA_MANILA",
            'ASIA_MUSCAT': "ASIA_MUSCAT",
            'ASIA_NICOSIA': "ASIA_NICOSIA",
            'ASIA_NOVOSIBIRSK': "ASIA_NOVOSIBIRSK",
            'ASIA_OMSK': "ASIA_OMSK",
            'ASIA_ORAL': "ASIA_ORAL",
            'ASIA_PHNOM_PENH': "ASIA_PHNOM_PENH",
            'ASIA_PONTIANAK': "ASIA_PONTIANAK",
            'ASIA_PYONGYANG': "ASIA_PYONGYANG",
            'ASIA_QATAR': "ASIA_QATAR",
            'ASIA_QYZYLORDA': "ASIA_QYZYLORDA",
            'ASIA_RANGOON': "ASIA_RANGOON",
            'ASIA_RIYADH': "ASIA_RIYADH",
            'ASIA_RIYADH87': "ASIA_RIYADH87",
            'ASIA_RIYADH88': "ASIA_RIYADH88",
            'ASIA_RIYADH89': "ASIA_RIYADH89",
            'ASIA_SAIGON': "ASIA_SAIGON",
            'ASIA_SAKHALIN': "ASIA_SAKHALIN",
            'ASIA_SAMARKAND': "ASIA_SAMARKAND",
            'ASIA_SEOUL': "ASIA_SEOUL",
            'ASIA_SHANGHAI': "ASIA_SHANGHAI",
            'ASIA_SINGAPORE': "ASIA_SINGAPORE",
            'ASIA_TAIPEI': "ASIA_TAIPEI",
            'ASIA_TASHKENT': "ASIA_TASHKENT",
            'ASIA_TBILISI': "ASIA_TBILISI",
            'ASIA_TEHRAN': "ASIA_TEHRAN",
            'ASIA_TEL_AVIV': "ASIA_TEL_AVIV",
            'ASIA_THIMBU': "ASIA_THIMBU",
            'ASIA_THIMPHU': "ASIA_THIMPHU",
            'ASIA_TOKYO': "ASIA_TOKYO",
            'ASIA_UJUNG_PANDANG': "ASIA_UJUNG_PANDANG",
            'ASIA_ULAANBAATAR': "ASIA_ULAANBAATAR",
            'ASIA_ULAN_BATOR': "ASIA_ULAN_BATOR",
            'ASIA_URUMQI': "ASIA_URUMQI",
            'ASIA_VIENTIANE': "ASIA_VIENTIANE",
            'ASIA_VLADIVOSTOK': "ASIA_VLADIVOSTOK",
            'ASIA_YAKUTSK': "ASIA_YAKUTSK",
            'ASIA_YEKATERINBURG': "ASIA_YEKATERINBURG",
            'ASIA_YEREVAN': "ASIA_YEREVAN",
            'AST': "AST",
            'ATLANTIC_AZORES': "ATLANTIC_AZORES",
            'ATLANTIC_BERMUDA': "ATLANTIC_BERMUDA",
            'ATLANTIC_CANARY': "ATLANTIC_CANARY",
            'ATLANTIC_CAPE_VERDE': "ATLANTIC_CAPE_VERDE",
            'ATLANTIC_FAEROE': "ATLANTIC_FAEROE",
            'ATLANTIC_JAN_MAYEN': "ATLANTIC_JAN_MAYEN",
            'ATLANTIC_MADEIRA': "ATLANTIC_MADEIRA",
            'ATLANTIC_REYKJAVIK': "ATLANTIC_REYKJAVIK",
            'ATLANTIC_SOUTH_GEORGIA': "ATLANTIC_SOUTH_GEORGIA",
            'ATLANTIC_ST_HELENA': "ATLANTIC_ST_HELENA",
            'ATLANTIC_STANLEY': "ATLANTIC_STANLEY",
            'AUSTRALIA_ACT': "AUSTRALIA_ACT",
            'AUSTRALIA_ADELAIDE': "AUSTRALIA_ADELAIDE",
            'AUSTRALIA_BRISBANE': "AUSTRALIA_BRISBANE",
            'AUSTRALIA_BROKEN_HILL': "AUSTRALIA_BROKEN_HILL",
            'AUSTRALIA_CANBERRA': "AUSTRALIA_CANBERRA",
            'AUSTRALIA_DARWIN': "AUSTRALIA_DARWIN",
            'AUSTRALIA_HOBART': "AUSTRALIA_HOBART",
            'AUSTRALIA_LHI': "AUSTRALIA_LHI",
            'AUSTRALIA_LINDEMAN': "AUSTRALIA_LINDEMAN",
            'AUSTRALIA_LORD_HOWE': "AUSTRALIA_LORD_HOWE",
            'AUSTRALIA_MELBOURNE': "AUSTRALIA_MELBOURNE",
            'AUSTRALIA_NORTH': "AUSTRALIA_NORTH",
            'AUSTRALIA_NSW': "AUSTRALIA_NSW",
            'AUSTRALIA_PERTH': "AUSTRALIA_PERTH",
            'AUSTRALIA_QUEENSLAND': "AUSTRALIA_QUEENSLAND",
            'AUSTRALIA_SOUTH': "AUSTRALIA_SOUTH",
            'AUSTRALIA_SYDNEY': "AUSTRALIA_SYDNEY",
            'AUSTRALIA_TASMANIA': "AUSTRALIA_TASMANIA",
            'AUSTRALIA_VICTORIA': "AUSTRALIA_VICTORIA",
            'AUSTRALIA_WEST': "AUSTRALIA_WEST",
            'AUSTRALIA_YANCOWINNA': "AUSTRALIA_YANCOWINNA",
            'BET': "BET",
            'BRAZIL_ACRE': "BRAZIL_ACRE",
            'BRAZIL_DENORONHA': "BRAZIL_DENORONHA",
            'BRAZIL_EAST': "BRAZIL_EAST",
            'BRAZIL_WEST': "BRAZIL_WEST",
            'BST': "BST",
            'CANADA_ATLANTIC': "CANADA_ATLANTIC",
            'CANADA_CENTRAL': "CANADA_CENTRAL",
            'CANADA_EAST_SASKATCHEWAN': "CANADA_EAST_SASKATCHEWAN",
            'CANADA_EASTERN': "CANADA_EASTERN",
            'CANADA_MOUNTAIN': "CANADA_MOUNTAIN",
            'CANADA_NEWFOUNDLAND': "CANADA_NEWFOUNDLAND",
            'CANADA_PACIFIC': "CANADA_PACIFIC",
            'CANADA_SASKATCHEWAN': "CANADA_SASKATCHEWAN",
            'CANADA_YUKON': "CANADA_YUKON",
            'CAT': "CAT",
            'CET': "CET",
            'CHILE_CONTINENTAL': "CHILE_CONTINENTAL",
            'CHILE_EASTERISLAND': "CHILE_EASTERISLAND",
            'CNT': "CNT",
            'CST': "CST",
            'CST6CDT': "CST6CDT",
            'CTT': "CTT",
            'CUBA': "CUBA",
            'EAT': "EAT",
            'ECT': "ECT",
            'EET': "EET",
            'EGYPT': "EGYPT",
            'EIRE': "EIRE",
            'EST': "EST",
            'EST5EDT': "EST5EDT",
            'ETC_GMT': "ETC_GMT",
            'ETC_GMT_PLUS_0': "ETC_GMT_PLUS_0",
            'ETC_GMT_PLUS_1': "ETC_GMT_PLUS_1",
            'ETC_GMT_PLUS_10': "ETC_GMT_PLUS_10",
            'ETC_GMT_PLUS_11': "ETC_GMT_PLUS_11",
            'ETC_GMT_PLUS_12': "ETC_GMT_PLUS_12",
            'ETC_GMT_PLUS_2': "ETC_GMT_PLUS_2",
            'ETC_GMT_PLUS_3': "ETC_GMT_PLUS_3",
            'ETC_GMT_PLUS_4': "ETC_GMT_PLUS_4",
            'ETC_GMT_PLUS_5': "ETC_GMT_PLUS_5",
            'ETC_GMT_PLUS_6': "ETC_GMT_PLUS_6",
            'ETC_GMT_PLUS_7': "ETC_GMT_PLUS_7",
            'ETC_GMT_PLUS_8': "ETC_GMT_PLUS_8",
            'ETC_GMT_PLUS_9': "ETC_GMT_PLUS_9",
            'ETC_GMT_MINUS_0': "ETC_GMT_MINUS_0",
            'ETC_GMT_MINUS_1': "ETC_GMT_MINUS_1",
            'ETC_GMT_MINUS_10': "ETC_GMT_MINUS_10",
            'ETC_GMT_MINUS_11': "ETC_GMT_MINUS_11",
            'ETC_GMT_MINUS_12': "ETC_GMT_MINUS_12",
            'ETC_GMT_MINUS_13': "ETC_GMT_MINUS_13",
            'ETC_GMT_MINUS_14': "ETC_GMT_MINUS_14",
            'ETC_GMT_MINUS_2': "ETC_GMT_MINUS_2",
            'ETC_GMT_MINUS_3': "ETC_GMT_MINUS_3",
            'ETC_GMT_MINUS_4': "ETC_GMT_MINUS_4",
            'ETC_GMT_MINUS_5': "ETC_GMT_MINUS_5",
            'ETC_GMT_MINUS_6': "ETC_GMT_MINUS_6",
            'ETC_GMT_MINUS_7': "ETC_GMT_MINUS_7",
            'ETC_GMT_MINUS_8': "ETC_GMT_MINUS_8",
            'ETC_GMT_MINUS_9': "ETC_GMT_MINUS_9",
            'ETC_GMT0': "ETC_GMT0",
            'ETC_GREENWICH': "ETC_GREENWICH",
            'ETC_UCT': "ETC_UCT",
            'ETC_UNIVERSAL': "ETC_UNIVERSAL",
            'ETC_UTC': "ETC_UTC",
            'ETC_ZULU': "ETC_ZULU",
            'EUROPE_AMSTERDAM': "EUROPE_AMSTERDAM",
            'EUROPE_ANDORRA': "EUROPE_ANDORRA",
            'EUROPE_ATHENS': "EUROPE_ATHENS",
            'EUROPE_BELFAST': "EUROPE_BELFAST",
            'EUROPE_BELGRADE': "EUROPE_BELGRADE",
            'EUROPE_BERLIN': "EUROPE_BERLIN",
            'EUROPE_BRATISLAVA': "EUROPE_BRATISLAVA",
            'EUROPE_BRUSSELS': "EUROPE_BRUSSELS",
            'EUROPE_BUCHAREST': "EUROPE_BUCHAREST",
            'EUROPE_BUDAPEST': "EUROPE_BUDAPEST",
            'EUROPE_CHISINAU': "EUROPE_CHISINAU",
            'EUROPE_COPENHAGEN': "EUROPE_COPENHAGEN",
            'EUROPE_DUBLIN': "EUROPE_DUBLIN",
            'EUROPE_GIBRALTAR': "EUROPE_GIBRALTAR",
            'EUROPE_HELSINKI': "EUROPE_HELSINKI",
            'EUROPE_ISTANBUL': "EUROPE_ISTANBUL",
            'EUROPE_KALININGRAD': "EUROPE_KALININGRAD",
            'EUROPE_KIEV': "EUROPE_KIEV",
            'EUROPE_LISBON': "EUROPE_LISBON",
            'EUROPE_LJUBLJANA': "EUROPE_LJUBLJANA",
            'EUROPE_LONDON': "EUROPE_LONDON",
            'EUROPE_LUXEMBOURG': "EUROPE_LUXEMBOURG",
            'EUROPE_MADRID': "EUROPE_MADRID",
            'EUROPE_MALTA': "EUROPE_MALTA",
            'EUROPE_MINSK': "EUROPE_MINSK",
            'EUROPE_MONACO': "EUROPE_MONACO",
            'EUROPE_MOSCOW': "EUROPE_MOSCOW",
            'EUROPE_NICOSIA': "EUROPE_NICOSIA",
            'EUROPE_OSLO': "EUROPE_OSLO",
            'EUROPE_PARIS': "EUROPE_PARIS",
            'EUROPE_PRAGUE': "EUROPE_PRAGUE",
            'EUROPE_RIGA': "EUROPE_RIGA",
            'EUROPE_ROME': "EUROPE_ROME",
            'EUROPE_SAMARA': "EUROPE_SAMARA",
            'EUROPE_SAN_MARINO': "EUROPE_SAN_MARINO",
            'EUROPE_SARAJEVO': "EUROPE_SARAJEVO",
            'EUROPE_SIMFEROPOL': "EUROPE_SIMFEROPOL",
            'EUROPE_SKOPJE': "EUROPE_SKOPJE",
            'EUROPE_SOFIA': "EUROPE_SOFIA",
            'EUROPE_STOCKHOLM': "EUROPE_STOCKHOLM",
            'EUROPE_TALLINN': "EUROPE_TALLINN",
            'EUROPE_TIRANE': "EUROPE_TIRANE",
            'EUROPE_TIRASPOL': "EUROPE_TIRASPOL",
            'EUROPE_UZHGOROD': "EUROPE_UZHGOROD",
            'EUROPE_VADUZ': "EUROPE_VADUZ",
            'EUROPE_VATICAN': "EUROPE_VATICAN",
            'EUROPE_VIENNA': "EUROPE_VIENNA",
            'EUROPE_VILNIUS': "EUROPE_VILNIUS",
            'EUROPE_WARSAW': "EUROPE_WARSAW",
            'EUROPE_ZAGREB': "EUROPE_ZAGREB",
            'EUROPE_ZAPOROZHYE': "EUROPE_ZAPOROZHYE",
            'EUROPE_ZURICH': "EUROPE_ZURICH",
            'GB': "GB",
            'GB_EIRE': "GB_EIRE",
            'GMT': "GMT",
            'GMT0': "GMT0",
            'GREENWICH': "GREENWICH",
            'HONGKONG': "HONGKONG",
            'HST': "HST",
            'ICELAND': "ICELAND",
            'IET': "IET",
            'INDIAN_ANTANANARIVO': "INDIAN_ANTANANARIVO",
            'INDIAN_CHAGOS': "INDIAN_CHAGOS",
            'INDIAN_CHRISTMAS': "INDIAN_CHRISTMAS",
            'INDIAN_COCOS': "INDIAN_COCOS",
            'INDIAN_COMORO': "INDIAN_COMORO",
            'INDIAN_KERGUELEN': "INDIAN_KERGUELEN",
            'INDIAN_MAHE': "INDIAN_MAHE",
            'INDIAN_MALDIVES': "INDIAN_MALDIVES",
            'INDIAN_MAURITIUS': "INDIAN_MAURITIUS",
            'INDIAN_MAYOTTE': "INDIAN_MAYOTTE",
            'INDIAN_REUNION': "INDIAN_REUNION",
            'IRAN': "IRAN",
            'ISRAEL': "ISRAEL",
            'IST': "IST",
            'JAMAICA': "JAMAICA",
            'JAPAN': "JAPAN",
            'JST': "JST",
            'KWAJALEIN': "KWAJALEIN",
            'LIBYA': "LIBYA",
            'MET': "MET",
            'MEXICO_BAJANORTE': "MEXICO_BAJANORTE",
            'MEXICO_BAJASUR': "MEXICO_BAJASUR",
            'MEXICO_GENERAL': "MEXICO_GENERAL",
            'MIDEAST_RIYADH87': "MIDEAST_RIYADH87",
            'MIDEAST_RIYADH88': "MIDEAST_RIYADH88",
            'MIDEAST_RIYADH89': "MIDEAST_RIYADH89",
            'MIT': "MIT",
            'MST': "MST",
            'MST7MDT': "MST7MDT",
            'NAVAJO': "NAVAJO",
            'NET': "NET",
            'NST': "NST",
            'NZ': "NZ",
            'NZ_CHAT': "NZ_CHAT",
            'PACIFIC_APIA': "PACIFIC_APIA",
            'PACIFIC_AUCKLAND': "PACIFIC_AUCKLAND",
            'PACIFIC_CHATHAM': "PACIFIC_CHATHAM",
            'PACIFIC_EASTER': "PACIFIC_EASTER",
            'PACIFIC_EFATE': "PACIFIC_EFATE",
            'PACIFIC_ENDERBURY': "PACIFIC_ENDERBURY",
            'PACIFIC_FAKAOFO': "PACIFIC_FAKAOFO",
            'PACIFIC_FIJI': "PACIFIC_FIJI",
            'PACIFIC_FUNAFUTI': "PACIFIC_FUNAFUTI",
            'PACIFIC_GALAPAGOS': "PACIFIC_GALAPAGOS",
            'PACIFIC_GAMBIER': "PACIFIC_GAMBIER",
            'PACIFIC_GUADALCANAL': "PACIFIC_GUADALCANAL",
            'PACIFIC_GUAM': "PACIFIC_GUAM",
            'PACIFIC_HONOLULU': "PACIFIC_HONOLULU",
            'PACIFIC_JOHNSTON': "PACIFIC_JOHNSTON",
            'PACIFIC_KIRITIMATI': "PACIFIC_KIRITIMATI",
            'PACIFIC_KOSRAE': "PACIFIC_KOSRAE",
            'PACIFIC_KWAJALEIN': "PACIFIC_KWAJALEIN",
            'PACIFIC_MAJURO': "PACIFIC_MAJURO",
            'PACIFIC_MARQUESAS': "PACIFIC_MARQUESAS",
            'PACIFIC_MIDWAY': "PACIFIC_MIDWAY",
            'PACIFIC_NAURU': "PACIFIC_NAURU",
            'PACIFIC_NIUE': "PACIFIC_NIUE",
            'PACIFIC_NORFOLK': "PACIFIC_NORFOLK",
            'PACIFIC_NOUMEA': "PACIFIC_NOUMEA",
            'PACIFIC_PAGO_PAGO': "PACIFIC_PAGO_PAGO",
            'PACIFIC_PALAU': "PACIFIC_PALAU",
            'PACIFIC_PITCAIRN': "PACIFIC_PITCAIRN",
            'PACIFIC_PONAPE': "PACIFIC_PONAPE",
            'PACIFIC_PORT_MORESBY': "PACIFIC_PORT_MORESBY",
            'PACIFIC_RAROTONGA': "PACIFIC_RAROTONGA",
            'PACIFIC_SAIPAN': "PACIFIC_SAIPAN",
            'PACIFIC_SAMOA': "PACIFIC_SAMOA",
            'PACIFIC_TAHITI': "PACIFIC_TAHITI",
            'PACIFIC_TARAWA': "PACIFIC_TARAWA",
            'PACIFIC_TONGATAPU': "PACIFIC_TONGATAPU",
            'PACIFIC_TRUK': "PACIFIC_TRUK",
            'PACIFIC_WAKE': "PACIFIC_WAKE",
            'PACIFIC_WALLIS': "PACIFIC_WALLIS",
            'PACIFIC_YAP': "PACIFIC_YAP",
            'PLT': "PLT",
            'PNT': "PNT",
            'POLAND': "POLAND",
            'PORTUGAL': "PORTUGAL",
            'PRC': "PRC",
            'PRT': "PRT",
            'PST': "PST",
            'PST8PDT': "PST8PDT",
            'ROK': "ROK",
            'SINGAPORE': "SINGAPORE",
            'SST': "SST",
            'SYSTEMV_AST4': "SYSTEMV_AST4",
            'SYSTEMV_AST4ADT': "SYSTEMV_AST4ADT",
            'SYSTEMV_CST6': "SYSTEMV_CST6",
            'SYSTEMV_CST6CDT': "SYSTEMV_CST6CDT",
            'SYSTEMV_EST5': "SYSTEMV_EST5",
            'SYSTEMV_EST5EDT': "SYSTEMV_EST5EDT",
            'SYSTEMV_HST10': "SYSTEMV_HST10",
            'SYSTEMV_MST7': "SYSTEMV_MST7",
            'SYSTEMV_MST7MDT': "SYSTEMV_MST7MDT",
            'SYSTEMV_PST8': "SYSTEMV_PST8",
            'SYSTEMV_PST8PDT': "SYSTEMV_PST8PDT",
            'SYSTEMV_YST9': "SYSTEMV_YST9",
            'SYSTEMV_YST9YDT': "SYSTEMV_YST9YDT",
            'TURKEY': "TURKEY",
            'UCT': "UCT",
            'UNIVERSAL': "UNIVERSAL",
            'US_ALASKA': "US_ALASKA",
            'US_ALEUTIAN': "US_ALEUTIAN",
            'US_ARIZONA': "US_ARIZONA",
            'US_CENTRAL': "US_CENTRAL",
            'US_EAST_INDIANA': "US_EAST_INDIANA",
            'US_EASTERN': "US_EASTERN",
            'US_HAWAII': "US_HAWAII",
            'US_INDIANA_STARKE': "US_INDIANA_STARKE",
            'US_MICHIGAN': "US_MICHIGAN",
            'US_MOUNTAIN': "US_MOUNTAIN",
            'US_PACIFIC': "US_PACIFIC",
            'US_PACIFIC_NEW': "US_PACIFIC_NEW",
            'US_SAMOA': "US_SAMOA",
            'UTC': "UTC",
            'VST': "VST",
            'W_SU': "W_SU",
            'WET': "WET",
            'ZULU': "ZULU",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'source_id': (str,),  # noqa: E501
            'uwi': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'fluid': (str,),  # noqa: E501
            'lift_type': (str,),  # noqa: E501
            'group1': (str, none_type,),  # noqa: E501
            'group2': (str, none_type,),  # noqa: E501
            'group3': (str, none_type,),  # noqa: E501
            'lat': (float, none_type,),  # noqa: E501
            'lon': (float, none_type,),  # noqa: E501
            'mud_line': (float, none_type,),  # noqa: E501
            'timezone': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'source_id': 'sourceId',  # noqa: E501
        'uwi': 'uwi',  # noqa: E501
        'name': 'name',  # noqa: E501
        'type': 'type',  # noqa: E501
        'fluid': 'fluid',  # noqa: E501
        'lift_type': 'liftType',  # noqa: E501
        'group1': 'group1',  # noqa: E501
        'group2': 'group2',  # noqa: E501
        'group3': 'group3',  # noqa: E501
        'lat': 'lat',  # noqa: E501
        'lon': 'lon',  # noqa: E501
        'mud_line': 'mudLine',  # noqa: E501
        'timezone': 'timezone',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, source_id, uwi, name, *args, **kwargs):  # noqa: E501
        """WellInput - a model defined in OpenAPI

        Args:
            source_id (str):
            uwi (str):
            name (str):

        Keyword Args:
            type (str): defaults to "PRODUCER", must be one of ["PRODUCER", "INJECTOR", ]  # noqa: E501
            fluid (str): defaults to "OIL", must be one of ["OIL", "GAS", "WATER", ]  # noqa: E501
            lift_type (str): defaults to "NATURAL_FLOW", must be one of ["NATURAL_FLOW", "GAS_LIFT", "ROD_PUMP", "ESP", "PLUNGER_LIFT", "GAS_ASSISTED_PLUNGER_LIFT", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            group1 (str, none_type): [optional]  # noqa: E501
            group2 (str, none_type): [optional]  # noqa: E501
            group3 (str, none_type): [optional]  # noqa: E501
            lat (float, none_type): [optional]  # noqa: E501
            lon (float, none_type): [optional]  # noqa: E501
            mud_line (float, none_type): [optional]  # noqa: E501
            timezone (str, none_type): [optional]  # noqa: E501
        """

        type = kwargs.get('type', "PRODUCER")
        fluid = kwargs.get('fluid', "OIL")
        lift_type = kwargs.get('lift_type', "NATURAL_FLOW")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.source_id = source_id
        self.uwi = uwi
        self.name = name
        self.type = type
        self.fluid = fluid
        self.lift_type = lift_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
